#include <usbdrv.h>

#define RQ_GET_SWITCH0  0
#define RQ_GET_SWITCH1  1
#define RQ_GET_SWITCH2  2
#define RQ_GET_SWITCH3  3

//////////////////////////////////////////////////////////////////////
usbMsgLen_t usbFunctionSetup(uint8_t data[8])
{
  usbRequest_t *rq = (usbRequest_t*)data;
  static uint8_t switch_state;


  if (rq->bRequest == RQ_GET_SWITCH0)
  {
    if (digitalRead(PIN_PC0) == HIGH) /* switch is pressed */ 
      switch_state = 1;
    else
      switch_state = 0;

    /* point usbMsgPtr to the data to be returned to host */
    usbMsgPtr = (uint8_t*) &switch_state;

    /* return the number of bytes of data to be returned to host */
    return sizeof(switch_state);
  }
  else if (rq->bRequest == RQ_GET_SWITCH1)
  {
    if (digitalRead(PIN_PC1) == HIGH) /* switch is pressed */ 
      switch_state = 1;
    else
      switch_state = 0;

    /* point usbMsgPtr to the data to be returned to host */
    usbMsgPtr = (uint8_t*) &switch_state;

    /* return the number of bytes of data to be returned to host */
    return sizeof(switch_state);
  }
  else if (rq->bRequest == RQ_GET_SWITCH2)
  {
    if (digitalRead(PIN_PC2) == HIGH) /* switch is pressed */ 
      switch_state = 1;
    else
      switch_state = 0;

    /* point usbMsgPtr to the data to be returned to host */
    usbMsgPtr = (uint8_t*) &switch_state;

    /* return the number of bytes of data to be returned to host */
    return sizeof(switch_state);
  }
  else if (rq->bRequest == RQ_GET_SWITCH3)
  {
    if (digitalRead(PIN_PC3) == HIGH) /* switch is pressed */ 
      switch_state = 1;
    else
      switch_state = 0;

    /* point usbMsgPtr to the data to be returned to host */
    usbMsgPtr = (uint8_t*) &switch_state;

    /* return the number of bytes of data to be returned to host */
    return sizeof(switch_state);
  }
  return 0;   /* nothing to do; return no data back to host */
}

//////////////////////////////////////////////////////////////////////
void setup()
{
    pinMode(PIN_PC0,INPUT);
    pinMode(PIN_PC1,INPUT);
    pinMode(PIN_PC2,INPUT);
    pinMode(PIN_PC3,INPUT);
    pinMode(PIN_PC4,INPUT);
    pinMode(PIN_PD3,OUTPUT);

    usbInit();

    /* enforce re-enumeration of USB devices */
    usbDeviceDisconnect();
    delay(300);
    usbDeviceConnect();
}

//////////////////////////////////////////////////////////////////////
void loop()
{
  usbPoll();
}
