import pygame
from pygame.locals import *
from random import *

class Bubble:
    def __init__(self,type = 0, time = 5):
        self.type = type
        self.vy = 2000                  #note speed
        self.time = time
        
        self.y = 20
	if(self.type == -1):
            self.type = randint(0,3)
	if self.type == 0:
            self.img = pygame.image.load("res/key_blue.png")
        elif self.type == 1:
            self.img = pygame.image.load("res/key_green.png")
        elif self.type == 2:
            self.img = pygame.image.load("res/key_purple.png")
        elif self.type == 3:
            self.img = pygame.image.load("res/key_red.png")
        self.init()
        
    def render(self,surface):
        surface.blit(self.img,(self.x,self.y))

    def init(self):
        if self.type == 0 or self.type == 4:
            self.x = 245
        elif self.type == 1 or self.type == 5:
            self.x = 465
        elif self.type == 2 or self.type == 6:
            self.x = 685
        elif self.type == 3 or self.type == 7:
            self.x = 905 
    
    #def change_speed(self):
        #self.vy += 100

    def move(self,delta_t, time):
        if time >= 1.0:
            self.y += self.vy*(1.0/delta_t)
        if int(time) == self.time+1:
            #self.change_speed()
            self.time += 1    

######################################
class Button:
    def __init__(self,type):
	self.type = type
	self.y = 650
        if self.type == 0:
            self.img = pygame.image.load("res/button_blue.png")
        elif self.type == 1:
            self.img = pygame.image.load("res/button_green.png")
        elif self.type == 2:
            self.img = pygame.image.load("res/button_purple.png")
        elif self.type == 3:
            self.img = pygame.image.load("res/button_red.png")
	elif self.type == 4:
            self.img = pygame.image.load("res/button_blue_afterpress.png")
        elif self.type == 5:
            self.img = pygame.image.load("res/button_green_afterpress.png")
        elif self.type == 6:
            self.img = pygame.image.load("res/button_purple_afterpress.png")
        elif self.type == 7:
            self.img = pygame.image.load("res/button_red_afterpress.png")
        self.init()

    def render(self,surface):
        surface.blit(self.img,(self.x,self.y))

        
    def init(self):
        if self.type == 0 or self.type == 4:
            self.x = 245
        elif self.type == 1 or self.type == 5:
            self.x = 465
        elif self.type == 2 or self.type == 6:
            self.x = 685
        elif self.type == 3 or self.type == 7:
            self.x = 905 

   
######################################
class Music(object):

    def __init__(self):
        self.musics = ['res/ED.mp3',
                       'res/OP.mp3',
                       'res/BraveShine.mp3',
                       'res/&Z.mp3',
		       'res/HikaruNaRa.mp3',
		       'res/Free.mp3']
        self.current_playing = None
        self.next_song = None
        pygame.mixer.init()
        #self.bg = Background()
        self.END_MUSIC_EVENT = pygame.USEREVENT + 0
        pygame.mixer.music.set_endevent(self.END_MUSIC_EVENT)

    def play_next_song(self):

	if self.current_playing == None:
	    m = 0
	else:
	    m = self.musics.index(self.current_playing)
	self.next_song = self.musics[(m+1)%6]

        
        self.current_playing = self.next_song
        print self.next_song,"in play_different()"
	
        
    def is_song_end(self):
        END_MUSIC_EVENT = pygame.USEREVENT + 0
        pygame.mixer.music.set_endevent(END_MUSIC_EVENT)
        events = pygame.event.get()
        for event in events:
            if event.type == self.END_MUSIC_EVENT and event.code == 0:
                return True
            else:
                return False
    
    def play(self):
        self.play_next_song()
        pygame.mixer.music.load(self.next_song)
        pygame.mixer.music.play()
        print "play song"
  #      self.play_different()
  #      pygame.mixer.music.queue(self.next_song)
  #      print self.next_song,"in play()"

    def pause(self):
        pygame.mixer.music.pause()
    def unpause(self):
        pygame.mixer.music.unpause()

    def stop(self):
        pygame.mixer.music.stop()
#######################################
class Background(object):
    def __init__(self):
        (self.x, self.y) = (0, 0)
        self.images = ("res/Start.jpg",
                       "res/ed.jpg",
		       "res/op.jpg",
		       "res/aldnoah.jpg",
                       "res/fate.jpg",
		       "res/shigastu.jpg",
		       "res/free.jpg",
                       "res/polygonBG.jpg") # add image in tuple 
        self.pic = self.images[0] # add image for first time
        self.time = 0
        self.count = 0
	self.music = Music()

    def change_image(self,is_ended = False,m = 0):

        if not is_ended: 
            if self.count < len(self.images)-1:
                self.count += 1
	    else:
                self.count = 1
        elif is_ended:
            self.count = len(self.images)-1

	#print "m"
	#print m
	#self.pic = self.images[self.count]
	if m > 0 and m < 7:
	    self.pic = self.images[m]
	else:
	    self.pic = self.images[self.count]

	
    def render(self,surface):
        self.img =pygame.image.load(self.pic)
        self.img =pygame.transform.scale(self.img,(1280,800))
      #  self.time += pygame.time.Clock().get_time()
      #  if self.time/1000.0 > 3000.0:
      #      self.change_image()
        surface.blit(self.img,(self.x,self.y))

#######################################
class Note(object):
    def __init__(self,song=1):
	if song == 1:
	    self.note = [[0,1,0,1,2,3,3,2,1,0,1,2,3,2,1,0,0,1,1,2,2,3,3,0,1,3,2,1,0,1,0,0,2,0,3,1,2,0,1,1,2,1,2,2,3,2,3,2,2,1,1,3,3,0,0],  	[4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,2,3,2,3,1,3,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,]]
	else:
	    self.note = [[-1]]

########################################################################
 
