import pygame
from pygame.locals import *

import gamelib
from element import *

from random import *
from practicum import findDevices
from peri import PeriBoard
from usb import USBError

class MUZiK(gamelib.SimpleGame):
    BLACK = pygame.Color('black')
    WHITE = pygame.Color('white')
    GREEN = pygame.Color('green')
    
    #Initialize things? 
    def __init__(self):
        super(MUZiK, self).__init__('MUZiK', MUZiK.BLACK)
        
        self.board = []
        for i,dev in enumerate(findDevices()):
            self.board = PeriBoard(dev)
            print "Board connect"
        self.pressed_switch = 0
        
        lock_d = Button(0)   	#Blue
        lock_f = Button(1)	#Green
        lock_j = Button(2)	#Purple
        lock_k = Button(3)	#Red
        self.lock_button = [lock_d,lock_f,lock_j,lock_k]
	self.press_button = []
	
        self.music = Music()
	self.high_score = 0
        self.bg = Background()
        self.is_started = False
        self.is_ended = False
	self.is_paused = False
        self.key_button = [K_d,K_f,K_j,K_k]
	self.m = 0
	
     
    #Initialize things   
    def init(self):
        super(MUZiK, self).init()
        
        self.bubble = []
        self.time = 0
        self.tmp_time = self.time
        self.score = 0
	self.perfect = 0
	self.great = 0
	self.nice = 0
	self.miss = 0
        self.hit = 0
	self.combo = 0
	self.maxcombo = 0
        self.life = 100
        self.chk_bg = False
        self.is_destroyed = True
	
	if self.music.current_playing == 'res/ED.mp3':
	    self.m = 1
	    self.bg.change_image(self.is_ended,self.m)
	elif self.music.current_playing == 'res/OP.mp3':
	    self.m = 2
	    self.bg.change_image(self.is_ended,self.m)
	elif self.music.current_playing == 'res/BraveShine.mp3':
	    self.m = 4
	    self.bg.change_image(self.is_ended,self.m)
	elif self.music.current_playing == 'res/&Z.mp3':
	    self.m = 3
	    self.bg.change_image(self.is_ended,self.m)
	elif self.music.current_playing == 'res/HikaruNaRa.mp3':
	    self.m = 5
	    self.bg.change_image(self.is_ended,self.m)
	elif self.music.current_playing == 'res/Free.mp3':
	    self.m = 6
	    self.bg.change_image(self.is_ended,self.m)
	
	self.notes = Note(self.m).note
        self.render_score()
	

    #Start Music   
    def start_game(self):
	self.music.play()
        self.init()
        self.is_started = True
        self.is_ended = False
        
	
    #Update status?
    def update(self):
	
        if not self.board == []:
            self.check_board()
        if self.is_started and self.is_paused == False:
            self.play_game()
            if self.chk_bg == False:
                print "in chk_bg"
                self.chk_bg = True
                
		print self.music.current_playing
		
            if self.music.is_song_end():
                print "song end"
                self.music.stop()
                #self.end_state()
            	self.is_started = False
            	self.is_ended = True
		self.hit = 0
	#elif self.is_paused == True:

        if self.time > 93 or self.life == 0:
	    if self.combo > self.maxcombo:
		self.maxcombo = self.combo
	    if self.maxcombo >= 70:
		self.score += 7000
	    elif self.maxcombo >= 50 and self.maxcombo <70:
		self.score += 5000
	    elif self.maxcombo >= 30 and self.maxcombo <50:
		self.score += 3000
            self.end_state()
            self.is_started = False
            self.is_ended = True
	    self.hit = 0

	self.press()
	self.chk_key()

    #Pause game
    def Pause_state(self):
	self.music.pause()
	if self.combo > self.maxcombo:
	    self.maxcombo = self.combo
	self.get_high_score()
	self.render_score()
	if self.chk_bg == True :
            self.bg.change_image(self.is_paused)
            self.chk_bg = False

     #Resume game
    def Resume_state(self):
	self.music.unpause()
	if self.chk_bg == True :
            self.bg.change_image(self.is_paused)
            self.chk_bg = False



    #End game
    def end_state(self):
        if not self.is_started and self.is_ended:
	    
	    

	    self.get_high_score()
	    if self.score > self.high_score:
		#print self.high_score
		#print self.score
		self.save_high_score(self.score)
		self.high_score = self.score
	    self.render_score()
            if self.chk_bg == True :
                self.bg.change_image(self.is_ended)
                self.chk_bg = False
            self.music.stop()
            print "stop music in end state"
	    self.hit = 0

    #Make image !!?
    def render(self, surface):
        self.bg.render(surface)
        
        if self.is_started and not self.is_paused: 
	    surface.blit(self.combo_image,(530,200))
            #surface.blit(self.time_image, (1025,10))
            self.render_bubble(surface)
            surface.blit(self.life_image,(1020,80))
            surface.blit(self.score_image,(1000,50))
	    self.render_press(surface)
        if self.is_ended or self.is_paused:
	    surface.blit(self.highscore_image,(530,200))
            surface.blit(self.score_image2,(530,240))
	    surface.blit(self.maxcombo_image,(530,280))	    
	    surface.blit(self.life_image2,(530,310))
            surface.blit(self.perfect_image,(530,350))
            surface.blit(self.great_image,(530,380))
            surface.blit(self.nice_image,(530,410))
            surface.blit(self.miss_image,(530,440))
            surface.blit(self.end_image,(530,490))
		
        if self.hit == 1:
            surface.blit(pygame.image.load("res/Miss.png"),(1025,90))	          
        elif self.hit == 2:
            surface.blit(pygame.image.load("res/Nice.png"),(1025,90))	    
        elif self.hit == 3:
            surface.blit(pygame.image.load("res/Great.png"),(1025,90))	    
        elif self.hit == 4:
            surface.blit(pygame.image.load("res/Perfect.png"),(1025,90))
	    

    def get_high_score(self):
    	# Default high score
    	self.high_score = 0
 
    	# Try to read the high score from a file
        try:
            high_score_file = open("high_score.txt", "r")
            self.high_score = int(high_score_file.read())
            high_score_file.close()
            #print("Highscore = %d" % self.high_score)
    	except IOError:
        # Error reading file, no high score
            print("There is no high score yet.")
    	except ValueError:
        # There's a file there, but we don't understand the number.
            print("I'm confused. Starting with no high score.")
 
    	#return high_score
 
 
    def save_high_score(self,new_high_score):
    	try:
        # Write the file to disk
            high_score_file = open("high_score.txt", "w")
            high_score_file.write(str(new_high_score))
            high_score_file.close()
    	except IOError:
        # Hm, can't write it.
            print("Unable to save the high score.") 

    #BOARD Start



    #BOARD!!!!        
    def check_board(self):
        board = self.board
	press_D = False
	press_F = False
	press_J = False
	press_K = False
        try:
            press_D = board.getSwitch1()
            press_F = board.getSwitch0()
	    press_J = board.getSwitch2()
	    press_K = board.getSwitch3()
        except USBError:
            pass
	if self.is_started == False:
            if press_J:
                self.start_game()
        if self.is_started and len(self.bubble)>0:
	    if press_D:
		k = K_d
	    elif press_F:
		k = K_f
	    elif press_J:
		k = K_j
	    elif press_K:
		k = K_k
 	    else:
		k = K_l
	    for b in self.bubble:
            	if b.y < 680 and b.y > 620:
                    self.check_board_press(b,5000,k)
                elif b.y < 700 and b.y > 600:
                    self.check_board_press(b,3000,k)
                elif b.y < 750 and b.y > 550:
                    self.check_board_press(b,1000,k)

    #Start game        
    def on_key_up(self,key):
        if self.is_started == False:
            if key == K_j:
                self.start_game()
	

    #Press to make after_press
    def press(self):
	keys = pygame.key.get_pressed()
	if self.is_started == False:
            if keys[K_j]:
                self.start_game()
	elif self.is_paused == True:
	    #print "Pause"
	    if keys[K_w]:
                self.Resume_state()
		self.is_paused = False
	if self.is_started == True:
	    if keys[K_d]:
	    	self.press_button.append(Button(4))
	    	#print "d"
	    if keys[K_f]:
	    	self.press_button.append(Button(5))
	    	#print "f"
	    if keys[K_j]:
	    	self.press_button.append(Button(6))
	    	#print "j"
	    if keys[K_k]:
	    	self.press_button.append(Button(7))
	    	#print "k"
            if keys[K_x]:
                self.is_started = False
		self.is_paused = False
            	self.is_ended = True
	    	self.hit = 0
		if self.combo > self.maxcombo:
		    self.maxcombo = self.combo
	    	if self.maxcombo >= 70:
		    self.score += 7000
	    	elif self.maxcombo >= 50 and self.maxcombo <70:
		    self.score += 5000
	    	elif self.maxcombo >= 30 and self.maxcombo <50:
		    self.score += 3000
		self.end_state()
	    if keys[K_q]:
                self.is_paused = True
	    	self.hit = 0
		self.Pause_state()

    #Press log multi                        	
    def chk_key(self):
	if len(self.bubble) > 0:
	    for b in self.bubble:
                if b.y < 680 and b.y > 620:
                    self.check_key_press(b,5000)
                elif b.y < 700 and b.y > 600:
                    self.check_key_press(b,3000)
                elif b.y < 750 and b.y > 550:
                    self.check_key_press(b,1000)


    def check_board_press(self,bubble,score,key):
	if key == K_d:
	    self.press_button.append(Button(4))
            if bubble.type == 0:
		self.combo += 1
            	self.score += score
            	print self.score
            	self.is_destroyed = False
            	if score == 5000:
                    self.hit = 4
		    self.perfect += 1 
            	elif score == 3000:
                    self.hit = 3
		    self.great += 1 
            	elif score == 1000:
                    self.hit = 2
		    self.nice += 1 
            
    	elif key == K_f:
	    self.press_button.append(Button(5))
            if bubble.type == 1:
		self.combo += 1
            	self.score += score
            	print self.score
            	self.is_destroyed = False
            	if score == 5000:
                    self.hit = 4
		    self.perfect += 1 
            	elif score == 3000:
                    self.hit = 3
		    self.great += 1 
            	elif score == 1000:
                    self.hit = 2
		    self.nice += 1 
            
    	elif key == K_j:
	    self.press_button.append(Button(6))
            if bubble.type == 2:
		self.combo += 1
            	self.score += score
            	print self.score
            	self.is_destroyed = False
            	if score == 5000:
                    self.hit = 4
		    self.perfect += 1 
            	elif score == 3000:
                    self.hit = 3
		    self.great += 1 
            	elif score == 1000:
                    self.hit = 2
		    self.nice += 1 
            
    	elif key == K_k:
	    self.press_button.append(Button(7))
            if bubble.type == 3:
		self.combo += 1
            	self.score += score
            	print self.score
            	self.is_destroyed = False
            	if score == 5000:
             	    self.hit = 4
            	elif score == 3000:
                    self.hit = 3
		    self.great += 1 
            	elif score == 1000:
                    self.hit = 2
		    self.nice += 1 
           
        if not self.is_destroyed:
            self.bubble_destroyer(bubble)



    #Chk press right or wrong?
    def check_key_press(self,bubble,score):
	keys = pygame.key.get_pressed()
	if keys[K_d]:
            if bubble.type == 0:
		self.combo += 1
            	self.score += score
            	print self.score
            	self.is_destroyed = False
            	if score == 5000:
                    self.hit = 4
		    self.perfect += 1 
            	elif score == 3000:
                    self.hit = 3
		    self.great += 1 
            	elif score == 1000:
                    self.hit = 2
		    self.nice += 1 
            
    	elif keys[K_f]:
            if bubble.type == 1:
		self.combo += 1
            	self.score += score
            	print self.score
            	self.is_destroyed = False
            	if score == 5000:
                    self.hit = 4
		    self.perfect += 1 
            	elif score == 3000:
                    self.hit = 3
		    self.great += 1 
            	elif score == 1000:
                    self.hit = 2
		    self.nice += 1 
            
    	elif keys[K_j]:
            if bubble.type == 2:
		self.combo += 1
            	self.score += score
            	print self.score
            	self.is_destroyed = False
            	if score == 5000:
                    self.hit = 4
		    self.perfect += 1 
            	elif score == 3000:
                    self.hit = 3
		    self.great += 1 
            	elif score == 1000:
                    self.hit = 2
		    self.nice += 1 
            
    	elif keys[K_k]:
            if bubble.type == 3:
		self.combo += 1
            	self.score += score
            	print self.score
            	self.is_destroyed = False
            	if score == 5000:
             	    self.hit = 4
            	elif score == 3000:
                    self.hit = 3
		    self.great += 1 
            	elif score == 1000:
                    self.hit = 2
		    self.nice += 1 
            
        if not self.is_destroyed:
            self.bubble_destroyer(bubble)
	
    #Make element for render
    def render_time(self):
        self.time += self.clock.get_time()/1000.0
        self.time_image = self.font.render("Time = %.3f" % self.time, 0,MUZiK.WHITE)
    
    #Score on screen when finish    
    def render_score(self):
	self.combo_image = pygame.font.SysFont("Sawasdee",30).render("%d COMBO" % self.combo, 0,MUZiK.WHITE)
	self.maxcombo_image = pygame.font.SysFont("Sawasdee",30).render("Max Combo = %d" % self.maxcombo, 0,MUZiK.BLACK)
        self.score_image = pygame.font.SysFont("Sawasdee",30).render("Score = %d" % self.score, 0,MUZiK.WHITE)
	self.score_image2 = pygame.font.SysFont("Sawasdee",30).render("Score = %d" % self.score, 0,MUZiK.BLACK)
	self.highscore_image = pygame.font.SysFont("Sawasdee",30).render("Highscore = %d" % self.high_score, 0,MUZiK.BLACK)
        self.life_image = pygame.font.SysFont("Sawasdee",30).render("Life = %d" % self.life, 0,MUZiK.WHITE)
	self.life_image2 = pygame.font.SysFont("Sawasdee",30).render("Life = %d" % self.life, 0,MUZiK.BLACK)
	self.perfect_image = pygame.font.SysFont("Sawasdee",30).render("%d Perfect" % self.perfect, 0,MUZiK.BLACK)
	self.great_image = pygame.font.SysFont("Sawasdee",30).render("%d Great" % self.great, 0,MUZiK.BLACK)
	self.nice_image = pygame.font.SysFont("Sawasdee",30).render("%d Nice" % self.nice, 0,MUZiK.BLACK)
	self.miss_image = pygame.font.SysFont("Sawasdee",30).render("%d Miss" % self.miss, 0,MUZiK.BLACK)
	if self.is_paused:
            self.end_image = pygame.font.SysFont("Sawasdee",30).render("Press W to Resume" , 0,MUZiK.BLACK)
	else:
            self.end_image = pygame.font.SysFont("Sawasdee",30).render("Press J or Third Button to Restart" , 0,MUZiK.BLACK)

    #Draw all of bubbles(key+lock)
    def render_bubble(self, surface):
        for lock in self.lock_button:
            lock.render(surface)
        
        if self.time > 1.0 and len(self.bubble) > 0:
            for bubble in self.bubble:
                bubble.render(surface)

    #Effect chk press
    def render_press(self, surface):
        for press in self.press_button:
            press.render(surface)
	    self.press_button.remove(press)

    #Move keynote down                 
    def move_bubble(self):
        for bubble in self.bubble:
            bubble.move(self.fps, self.time)
            if bubble.y > 900:
                self.bubble_destroyer(bubble)
                self.life -= 5
		self.hit = 1
		self.miss += 1
		if self.combo > self.maxcombo:
		    self.maxcombo = self.combo
		self.combo = 0
		#print self.time

    #Make new keynote
    def bubble_creator(self,type):
        self.bubble.append(Bubble(type,time = int(self.time)))
        #print self.time

    #Throw keynote away
    def bubble_destroyer(self,bubble):
        self.bubble.remove(bubble)
        self.is_destroyed = True
        print "remove"
	#print self.time

    #All
    def play_game(self): 
        self.render_time()
        self.render_score()
        
        if len(self.bubble) > 0:
            self.move_bubble()
        
        if int(self.time) == self.tmp_time+2 and self.time < 89:
	    for note in self.notes:
		ntype = note[int(self.time)%len(note)]
		if ntype != 4:
            	    self.bubble_creator(ntype)
            self.tmp_time += 1

def main():
    game = MUZiK()
    game.run()

if __name__ == '__main__':
    main()
